"""
    Ubiquity REST API

    Ubiquity provides a RESTful and uniform way to access accountchain resources, with a rich and reusable model across multiple cryptocurrencies.  [Documentation](https://app.blockdaemon.com/docs/ubiquity)  ### Protocols #### Mainnet The following protocols are currently supported: * bitcoin * ethereum * polkadot * xrp * algorand * stellar  #### Testnet Testnet support coming soon  ##### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available.   # noqa: E501

    The version of the OpenAPI document: 2.0.0
    Contact: support@blockdaemon.com
    Generated by: https://openapi-generator.tech
"""

import json
import unittest

import test.mock
import test.utils
import ubiquity
from ubiquity.api import (
    accounts_api,
    ApiClient,
)
from ubiquity import Configuration

import httpretty
import urllib3


class TestAccountsApi(unittest.TestCase):
    """AccountsApi unit test stubs"""
    def setUp(self):
        self.api_client = ApiClient(Configuration())
        self.api_instance = accounts_api.AccountsApi(
            self.api_client)  # noqa: E501
        self.platforms = test.utils.get_platforms()
        self.accounts_by_platform = {
            "algorand":
            "5K6J3Z54656IR7YY65WNJT54UW6RBZZYL5LWQUTG4RWOTRTRBE2MR2AODQ",
            "bitcoin": "bc1q0e3vshzcp8kntj2ynqaxt32sqshqf36tl8xdmz",
            "ethereum": "0x30B2f83e291f952850DFB13380F6c71b24FDF97c",
            "polkadot": "1622aMEugx8d9FMEPJaknxCR5eUXSCJA5GANhdxYxwgA29vH",
            "stellar":
            "GDJ5VRKEVCDDFQPI3UYAJPU35NHPCML3JCFYH7J456GAOAL3NKVSE7YM",
            "xrp": "rh3VLyj1GbQjX7eA15BwUagEhSrPHmLkSR"
        }

        # Assert all listed platforms have an account id created above for testing
        assert len(self.accounts_by_platform) == len(self.platforms)

    def tearDown(self):
        pass

    @httpretty.activate(verbose=True, allow_net_connect=False)
    def test_get_account_balances(self):
        network = 'mainnet'
        supported_platforms = test.mock.get_supported_platforms(
            self.platforms, '/account/:address')
        assert len(supported_platforms) > 0
        for platform in supported_platforms:
            account_id = self.accounts_by_platform[platform]

            test.mock.setup_mock_server(self.api_client.configuration.host, [{
                "req_url":
                f"/{platform}/{network}/account/{account_id}",
                "method":
                httpretty.GET,
                "status":
                200,
                "response_data":
                test.mock.get_mock_file_content(
                    f'accounts_api/{platform}_account_{account_id}.json')
            }])
            _ = self.api_instance.get_balances_by_address(platform, network, account_id)

    @httpretty.activate(verbose=True, allow_net_connect=False)
    def test_get_account_txs(self):
        network = 'mainnet'
        supported_platforms = test.mock.get_supported_platforms(
            self.platforms, '/account/:address/txs')
        assert len(supported_platforms) > 0
        print("Supported platforms:", supported_platforms)

        for platform in supported_platforms:
            account_id = self.accounts_by_platform[platform]

            test.mock.setup_mock_server(self.api_client.configuration.host, [{
                "req_url":
                f"/{platform}/{network}/account/{account_id}/txs",
                "method":
                httpretty.GET,
                "status":
                200,
                "response_data":
                test.mock.get_mock_file_content(
                    f'accounts_api/{platform}_account_{account_id}_txs.json')
            }])
            _ = self.api_instance.get_txs_by_address(platform, network, account_id)


if __name__ == '__main__':
    unittest.main()
